#!/bin/bash

#
# Lecture parametres
#
cheminTarball=$1
offset=$2

if [ -z "$offset" ]; then
offset=0
fi

. $(dirname $0)/config.sh


#set -x
#trap read debug

#
#
# FORMAT / SPL / U-BOOT / PARTITION
#
#

umount ${card}*
sleep 4s
umount ${card}*


dd if=/dev/zero of=${card} bs=1M count=1
dd if=u-boot/u-boot-sunxi-with-spl.bin of=${card} bs=1024 seek=8

if [ $allocEspace == "sys" ]; then
cat <<EOT | sfdisk --in-order -uM ${card}
$(echo 8 + $offset | bc),16,c
,$(echo $(sfdisk -s ${card}) "/ 1024 - 25 - 50 - $offset" | bc),L
,,L
EOT
else
cat <<EOT | sfdisk --in-order -uM ${card}
$(echo 8 + $offset | bc),16,c
,3680,L
,,L
EOT
fi

sleep 4s

mkfs.vfat ${card}${p}1
mkfs.ext4 ${card}${p}2


#
#
# BOOT
#
#

mount ${card}${p}1 /mnt/
cp kernel/uImage /mnt/
cp script.bin /mnt/
cp u-boot/u-boot-nand.bin /mnt

cat <<EOT > /mnt/boot.cmd
setenv verify no
setenv bootargs console=ttyS0,115200 root=/dev/mmcblk0p2 rootwait panic=10
fatload mmc 0 0x43000000 script.bin || ext2load mmc 0 0x43000000 boot/script.bin
fatload mmc 0 0x48000000 uImage || ext2load mmc 0 0x48000000 uImage boot/uImage
bootm 0x48000000
EOT
mkimage -C none -A arm -T script -d /mnt/boot.cmd /mnt/boot.scr


umount /mnt/

#
#
# ROOT FS
#
#

mount ${card}${p}2 /mnt/

#echo T0:2345:respawn:/sbin/getty -L ttyS0 115200 vt100 >> /mnt/etc/inittab
tar --directory /mnt -xjvf "$cheminTarball"

echo malinuxTablette > /mnt/etc/hostname

cat <<END > /mnt/etc/fstab
/dev/mmcblk0p1    /boot	vfat	defaults		0	0 
/dev/mmcblk0p2    /		ext4	defaults,noatime,ro	0	0 
tmpfs	/tmp		tmpfs	defaults,size=15M	0	0

unionfs-fuse#/tmp=rw:/ro/var=ro		/var 	fuse	cow,allow_other,nonempty
unionfs-fuse#/tmp=rw:/ro/home=ro	/home	fuse	cow,allow_other
unionfs-fuse#/tmp=rw:/ro/media=ro	/media	fuse	cow,allow_other

END

mkdir -p /mnt/lib/modules
rm -rf /mnt/lib/modules/
cp -rv kernel/output/lib /mnt/
umount /mnt

sync

